#!/usr/bin/python

from Cheetah.Template import Template




configItems = [
    {"label":"_", "key":"magic", "type":"I", "default": ""},
    {"label":"Config Username", "key":"confUser", "type":"C", "length":16, "default":"admin"},
    {"label":"Config Password", "key":"confPasswd", "type":"C", "length":16, "default":"geheim123"},
    {"label":"Wifi SSID", "key":"wifiSsid", "type":"C", "length":32, "default":"test"},
    {"label":"Wifi Key", "key":"wifiKey", "type":"C", "length":64, "default":"geheim"},
    {"label":"MQTT Broker", "key":"mqttBroker", "type":"C", "length":32, "default":"broker.hottis.de"},
    {"label":"MQTT Username", "key":"mqttUser", "type":"C", "length":32, "default":"MySwitch1"},
    {"label":"MQTT Password", "key":"mqttPass", "type":"C", "length":32, "default":"geheim123"},
    {"label":"MQTT ClientId", "key":"mqttClientId", "type":"C", "length":32, "default":"MySwitch1"},
    {"label":"MQTT Port", "key":"mqttPort", "type":"I", "default":8883},
    {"label":"MQTT Switch Topic", "key":"mqttSwitchTopic", "type":"C", "length":64, "default":"IoT/MySwitch1/Value"},
    {"label":"MQTT LED Topic", "key":"mqttLedTopic", "type":"C", "length":64, "default":"IoT/MySwitch1/Led"},
    {"label":"MQTT DebugTopic", "key":"mqttDebugTopic", "type":"C", "length":64, "default":"IoT/MySwitch1/Debug"},
    {"label":"DebugMode", "key":"debugMode", "type":"I", "default":0},
    {"label":"Debounce (us)", "key":"debounce", "type":"I", "default":300},
    {"label":"Long press (ms)", "key":"longPress", "type":"I", "default":1500},
    {"label":"Long press repeat (ms)", "key":"longPressRepeat", "type":"I", "default":1000},
]


magic = 0xC0DE0005
appName = "ESP8266 based MySwitch"
confWifiSsid = "espconfig"

params = {
    "magic":magic,
    "appName":appName,
    "confWifiSsid":confWifiSsid,
    "configItems":configItems
}

h_file = Template(file="configuration_h.tmpl", searchList=[params])
open('configuration.h','w').write(str(h_file))
c_file = Template(file="configuration_c.tmpl", searchList=[params])
open('configuration.cpp','w').write(str(c_file))
